=== debian/changelog ===
ros-melodic-azure-iot-sdk-c (1.9.0-1bionic) bionic; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Tim Clephas <tim.clephas@nobleo.nl>  Mon, 24 Jan 2022 09:44:03 -0000
